#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<int> m;
int n, k;

vector<int> t;

void build(int l, int r, int v) {
    if (l == r) {
        t[v] = m[l];
        return;
    }
    int mid = (r + l) / 2;
    build(l, mid, v * 2);
    build(mid + 1, r, v * 2 + 1);
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}

ll inf = 1e18;

ll find(int sl, int sr, int l, int r, int v) {
    if (sl > r || l > sr) return inf;
    if (sl <= l && r <= sr) {
        return t[v];
    }
    int mid = (r + l) / 2;
    ll a = find(sl, sr, l, mid, v * 2);
    ll b = find(sl, sr, mid + 1, r, v * 2 + 1);
    return min(a, b);
}

void solve() {
    cin >> n >> k;
    m.resize(n + 1);
    vector<int> pref(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> m[i];
        pref[i] = pref[i - 1] + m[i];
    }
    t.resize(4 * n);
    build(1, n, 1);
    ll ans = 0;
    int len = n - k + 1;
    for (int i = 1; i <= k; i++) {
        ll mn1 = find(1, i - 1, 1, n, 1);
        ll mn2 = find(i + len, n, 1, n, 1);
        ll sum = pref[i + len - 1] - pref[i - 1];
        ans = max(ans, abs(sum - min(mn1, mn2)));
    }
    cout << ans;
}

int main() {
    // freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
